// -*-c++-*-
/*
The MIT License (MIT)

Copyright (c) 2014 J. Eric Townsend

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

/* Color Picker 
 * 
 * Joystick
 * 3 pin LED
 *
 *  
 * Auto caliberates in the first 5 seconds (press/cover the sensor)
 * 
 */

// using code from class code &
// https://brainy-bits.com/blogs/tutorials/arduino-joystick-tutorial

// Joystick
const int SW_pin = 2; // digital pin connected to switch output
const int X_pin = 0; // analog pin connected to X output
const int Y_pin = 1; // analog pin connected to Y output

//RGB LED
int redPin = 9;
int greenPin = 12;
int bluePin = 11;

int RColor = 255;
int GColor = 0;
int BColor = 0;
int SerialInput = 1;

int toggleState =0;

int DEBUG = 1;
void setup()
{
  pinMode(redPin, OUTPUT);
  pinMode(greenPin, OUTPUT);
  pinMode(bluePin, OUTPUT);  
  pinMode(SW_pin, INPUT);
  digitalWrite(SW_pin, HIGH);
  attachInterrupt (digitalPinToInterrupt (SW_pin), switchPressed, CHANGE);
  if (DEBUG==1)
  {Serial.begin(115200);
  }
}

void switchPressed()
{
  if (digitalRead(SW_pin) == LOW) {
    toggleState == 4 ? toggleState = 0 : toggleState++;
  }
}

void setColor(int red, int green, int blue)
{
   // State Machin
   switch (toggleState){
    case 0: setColorLeds(0,0,0);break;
    case 1: setColorLeds(red,green,blue); break;
    case 2: setColorLeds(blue,red,green); break;
    case 3: setColorLeds(green,blue,red); break;
    case 4: setColorLeds(255,255,255); break;
  }


}

void setColorLeds(int red, int green, int blue)
{
  analogWrite(redPin, red);
  analogWrite(greenPin, green);
  analogWrite(bluePin, blue); 
   if(DEBUG==1)
  {
    Serial.print(analogRead(X_pin));
    Serial.print(",");
    Serial.print(analogRead(Y_pin));
    Serial.print(",");
    Serial.print(red);
    Serial.print(",");
    Serial.print(green);
    Serial.print(",");
    Serial.print(blue);
    Serial.print(",");
    Serial.print(toggleState);
    Serial.print("\r\n");
  } 
}

void updateInput(int pinData, int &ColorData)
{
  if((pinData>1000)&&(ColorData >0))
  {

    ColorData-=SerialInput;
    
  }

  if((pinData<100)&&(ColorData <250))
  {
    ColorData+=SerialInput;

  }

}

void joy() {

  int Y_data = analogRead(Y_pin);
  int X_data = analogRead(X_pin);
  if(DEBUG==2)
  {
    Serial.print("Switch:  ");
    Serial.print(digitalRead(SW_pin));
    Serial.print("\n");
    Serial.print("X-axis: ");
    Serial.print(analogRead(X_pin));
    Serial.print("\n");
    Serial.print("Y-axis: ");
    Serial.println(analogRead(Y_pin));
    Serial.print("\n\n");

    Serial.print(" R:  ");
    Serial.print(RColor);
    Serial.print(" G:  ");
    Serial.print(GColor);
    Serial.print(" B:  ");
    Serial.print(BColor);
    Serial.print(" T:  ");
    Serial.print(toggleState);
    Serial.print("\n\n");
  }

 
  
  updateInput(Y_data, GColor);
  updateInput(X_data, BColor);
  
  

  
  
}



void loop() {

  setColor(RColor, GColor, BColor);  // red
  joy();
}